
Redmine - Feature #7056

Download all attachments at once

2010-12-06 18:26 - Chris Haverman

Status: Closed Start date: 2010-12-06

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Attachments Estimated time: 0.00 hour

Target version: 4.2.0   

Resolution: Fixed   

Description

Did a quick search to see if this had been reported; didn't see anything.

Basically I'd like there to be a way to download all attachments to an issue in a single click rather than each one separately.

Related issues:

Related to Redmine - Feature #8708: Provide a "download multiple files at onc... Reopened 2011-06-29

Related to Redmine - Feature #35462: Download all attachments in a journal Closed

Has duplicate Redmine - Feature #2662: Download a document Closed 2009-02-04

Associated revisions

Revision 19601 - 2020-03-21 06:59 - Go MAEDA

Download all attachments at once (#7056).

Patch by Mizuki ISHIKAWA.

Revision 19602 - 2020-03-21 07:07 - Go MAEDA

Update locales (#7056).

Revision 19603 - 2020-03-22 03:23 - Go MAEDA

Update rubyzip to 2.3 (#7056).

Revision 19609 - 2020-03-23 06:52 - Go MAEDA

Display bulk_download_max_size in human-readable representation (#7056).

Patch by Go MAEDA.

Revision 19631 - 2020-04-01 11:14 - Go MAEDA

Replace File#readable? with Attachment#readable? (#7056).

Revision 19635 - 2020-04-02 07:52 - Go MAEDA

Replace File#readable? with Attachment#readable? (#7056).

Revision 19688 - 2020-04-11 09:58 - Go MAEDA

Fix that bulk download raises Errno::EACCES on Windows (#7056).

Patch by Yuichi HARADA.

History

#1 - 2010-12-15 18:10 - zac folk

I agree, this would be really useful.

#2 - 2013-02-14 13:40 - Motaz Abuthiab

+1

#3 - 2013-11-18 11:51 - Nicolas QUETGLAS
+1

#4 - 2015-03-08 03:19 - Go MAEDA

- Related to Feature #8708: Provide a "download multiple files at once" feature added

#5 - 2017-05-14 15:12 - Nikolay Yurchenko

+1

#6 - 2018-07-09 11:21 - Klément Grisel

+1

#7 - 2018-10-11 07:30 - Mizuki ISHIKAWA

- File compress_the_all_attachments_in_issue.patch added

In order to realize this feature, I thought of compressing and downloading Issue's attachment.

By applying this patch, you can download all of the attached files as a zip file. (using gem rubyzip)

Non-ascii file names are garbled in older versions (Windows 7, Windows Vista, Windows XP).

Windows 7 is scheduled to end support in 2020.

https://github.com/rubyzip/rubyzip/wiki/Files-with-non-ascii-filenames

Any feedback on this patch is welcome.

#8 - 2018-10-31 15:44 - Go MAEDA

Thank you for posting the patch. Could you explain why attachments_to_zip method creates temporary files in Attachment.storage_path instead of

tmp directory?

#9 - 2018-11-02 04:41 - Go MAEDA

I think the patch should consider the free space of the disk. Suppose that the total size of attachments of the issue is 1GB. If the free space of the disk

is less than 1GB, the creation of a zip archive will fail and the server may stop working due to disk full.

Here are some ideas to avoid the problem.

Show an error message indicates no sufficient disk space if the total size of attachments exceeds the free disk space

Create and send a zip archive without creating a temporary file

#10 - 2018-12-25 03:47 - Mizuki ISHIKAWA

- File compress_the_all_attachments_in_issue_v2.patch added

- File error_message.png added

Go MAEDA wrote:

Thank you for posting the patch. Could you explain why attachments_to_zip method creates temporary files in Attachment.storage_path instead

of tmp directory?

 There was no particular reason. I changed the temporary file storage location to the tmp directory.

Go MAEDA wrote:

I think the patch should consider the free space of the disk. Suppose that the total size of attachments of the issue is 1GB. If the free space of

the disk is less than 1GB, the creation of a zip archive will fail and the server may stop working due to disk full.

Here are some ideas to avoid the problem.

Show an error message indicates no sufficient disk space if the total size of attachments exceeds the free disk space

Create and send a zip archive without creating a temporary file

 Thank you for your feedback.

Because I could not think of a good way to check disk space, I thought about limiting the maximum capacity of temporary files.

The maximum capacity of temporary file can be set in configration.yml.

By doing this setting, it is impossible to create a temporary file larger than the assumption of the server administrator.

 error_message.png 
#11 - 2019-02-28 13:09 - Go MAEDA

- Target version set to Candidate for next major release

#12 - 2019-12-19 05:31 - Go MAEDA

Mizuki ISHIKAWA wrote:

Non-ascii file names are garbled in older versions (Windows 7, Windows Vista, Windows XP).

 I don't think this is a problem because Windows 7 is going to reach EOL next month (2020-01-14).

https://www.microsoft.com/en-us/microsoft-365/windows/end-of-windows-7-support

#13 - 2019-12-20 01:57 - Mizuki ISHIKAWA

- File compress_the_all_attachments_in_issue_v3.patch added

I modified the patch to apply to the latest trunk.

#14 - 2020-02-18 08:43 - Go MAEDA

- File screenshot-v4.png added

- File compress_the_all_attachments_in_issue_v4.patch added

I have changed the patch:

Add a label to the bulk download button

Move the button to below the attachments list (like usability plugin)

Updated messages

Raised the default value for bulk_download_max_size to 512MB

 

#15 - 2020-03-05 04:50 - Go MAEDA

- Has duplicate Feature #2662: Download a document added

#16 - 2020-03-07 16:12 - Go MAEDA

- File compress_the_all_attachments_in_issue_v5.patch added

I have updated the patch. Moved bulk_download_max_size setting from configuration.yml to /settings GUI for consistency.
#17 - 2020-03-08 00:23 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.

#18 - 2020-03-14 05:39 - Go MAEDA

- File compress_the_all_attachments_in_issue_v6.patch added

Slightly updated the patch:

Changed the method name Attachment.attachments_to_zip to Attachment.archive_attachments because attachments_to_zip is too specific. No

one knows if the feature uses ZIP format forever, so I think the method name should not depend on a specific archive format

Changed the text for label_download_all_attachments from "Download all attached files" to simpler "Download all files"

#19 - 2020-03-15 03:26 - Go MAEDA

- File attachments-that-causes-EntryExistsError@2x.png added

- File compress_the_all_attachments_in_issue_v7.patch added

The patch may raise Zip::EntryExistsError when you try to download a ZIP file if a file that has "(2)" suffix in its basename is attached.

 

Started GET "/attachments/issues/32/download" for 127.0.0.1 at 2020-03-15 10:59:03 +0900

Processing by AttachmentsController#download_all as HTML

.

.

.

Completed 500 Internal Server Error in 28ms (ActiveRecord: 4.9ms)

Zip::EntryExistsError (add failed. Entry testfile(2).txt already exists):

app/models/attachment.rb:362:in `block (2 levels) in archive_attachments'

app/models/attachment.rb:355:in `each'

app/models/attachment.rb:355:in `block in archive_attachments'

app/models/attachment.rb:354:in `archive_attachments'

app/controllers/attachments_controller.rb:139:in `block in download_all'

app/controllers/attachments_controller.rb:138:in `download_all'

lib/redmine/sudo_mode.rb:64:in `sudo_mode'

 I have fixed the above issue. Also, I have changed the "(n)" suffix for duplicate filenames to start from 1 instead of 2. It is the same behavior as

Chrome and Firefox do when downloading files with the same name.

#20 - 2020-03-15 14:13 - Marius BĂLTEANU

- File download.png added

I like this feature.

What do you think if we show the link next to edit attached files icon (as Mizuki proposed first time) in order to keep the links grouped?

 download.png 

I don't find very UX friendly to have the Edit button to the right and the "Download all" button under attachments and thumbnails.

#21 - 2020-03-15 14:18 - Marius BĂLTEANU

- Related to deleted (Feature #8708: Provide a "download multiple files at once" feature)

#22 - 2020-03-15 14:18 - Marius BĂLTEANU

- Has duplicate Feature #8708: Provide a "download multiple files at once" feature added

#23 - 2020-03-15 14:21 - Marius BĂLTEANU
Also, we should add a test for the new route added by this patch.

#24 - 2020-03-15 14:58 - Marius BĂLTEANU

- Has duplicate deleted (Feature #8708: Provide a "download multiple files at once" feature)

#25 - 2020-03-15 14:59 - Marius BĂLTEANU

- Related to Feature #8708: Provide a "download multiple files at once" feature added

#26 - 2020-03-16 07:41 - Go MAEDA

Marius BALTEANU wrote:

What do you think if we show the link next to edit attached files icon (as Mizuki proposed first time) in order to keep the links grouped?

 I prefer the current position becuase the position you suggest is very far from the list of files and many people may not notice this useful feature. But it

is OK to move the button to the right if we can move this patch forward by doing that.

#27 - 2020-03-16 09:37 - Marius BĂLTEANU

Go MAEDA wrote:

Marius BALTEANU wrote:

What do you think if we show the link next to edit attached files icon (as Mizuki proposed first time) in order to keep the links grouped?

 I prefer the current position becuase the position you suggest is very far from the list of files and many people may not notice this useful feature.

But it is OK to move the button to the right if we can move this patch forward by doing that.

 I agree with you that having all the action icons in the right corner is maybe not the best option, but this is in the current UI and we cannot just drop

some action icons in other places. We should keep the consistency and if we do a change to resolve the distance, we should do it for all the icons

because there is no difference between the Edit icon and Delete icon. In all other screens we have the icons one after each other. From my point of

view, we can commit this if we move the icon and add the missing test.

#28 - 2020-03-17 02:57 - Mizuki ISHIKAWA

- File compress_the_all_attachments_in_issue_v8.patch added

- File diff_v7_and_v8.patch added

Thanks for contributions for releasing this feature.

I updated the patch.

Add tests to test/integration/routing/attachments_test.rb

Move icon position to original position

#29 - 2020-03-21 07:03 - Go MAEDA

- Subject changed from Download All Attachments in Issue to Download all attachments at once

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for improving Redmine.

#30 - 2020-03-22 05:25 - Go MAEDA

- File human-readable-file-size.patch added

- File file-size-before@2x.png added

- File file-size-after@2x.png added

- Status changed from Closed to Reopened

The attached patch human-readable-file-size.patch fixes the format of file size in the message error_bulk_download_size_too_big to human-readable.

Before:
After:

 

#31 - 2020-03-23 06:53 - Go MAEDA

- Status changed from Reopened to Closed

Go MAEDA wrote:

The attached patch human-readable-file-size.patch fixes the format of file size in the message error_bulk_download_size_too_big to

human-readable.

 Committed the patch in r19609.

#32 - 2020-03-24 21:52 - Pavel Rosický

- File download_all_fix.patch added

unfortunately, this feature doesn't work on Windows.

Error:

AttachmentTest#test_archive_attachments:

Errno::EACCES: Permission denied @ rb_file_s_rename - (c:/redmine/tmp/attachments_zip20200324-12432-yknlax2020

0324-12432-1qjlddf, c:/redmine/tmp/attachments_zip20200324-12432-yknlax)

    app/models/attachment.rb:355:in `archive_attachments'

    test/unit/attachment_test.rb:284:in `block in test_archive_attachments'

    test/unit/attachment_test.rb:283:in `test_archive_attachments'

 I've attached a quick fix.

#33 - 2020-03-25 03:27 - Go MAEDA

- Status changed from Closed to Reopened

#34 - 2020-04-08 04:11 - Yuichi HARADA

- File zip-create-via-stream.patch added

Pavel Rosický wrote:

unfortunately, this feature doesn't work on Windows.

[...]

 Thanks for reporting this problem.

I fixed it to create a zip file via stream. No temporary file is needed.
diff --git a/app/controllers/attachments_controller.rb b/app/controllers/attachments_controller.rb

index b69dcf983..0c76490b2 100644

--- a/app/controllers/attachments_controller.rb

+++ b/app/controllers/attachments_controller.rb

@@ -137,16 +137,16 @@ class AttachmentsController < ApplicationController

   end

   def download_all

-    Tempfile.create('attachments_zip-', Rails.root.join('tmp')) do |tempfile|

-      zip_file = Attachment.archive_attachments(tempfile, @attachments)

-      if zip_file

-        send_data(

-          File.read(zip_file.path),

-          :type => 'application/zip',

-          :filename => "#{@container.class.to_s.downcase}-#{@container.id}-attachments.zip")

-      else

-        render_404

-      end

+    zip_data = Attachment.archive_attachments(@attachments)

+    if zip_data

+      file_name = "#{@container.class.to_s.downcase}-#{@container.id}-attachments.zip" 

+      send_data(

+        zip_data,

+        :type => Redmine::MimeType.of(file_name),

+        :filename => file_name

+      )

+    else

+      render_404

     end

   end

diff --git a/app/models/attachment.rb b/app/models/attachment.rb

index b5a3332ac..734b8f7fa 100644

--- a/app/models/attachment.rb

+++ b/app/models/attachment.rb

@@ -346,28 +346,28 @@ class Attachment < ActiveRecord::Base

     Attachment.where("created_on < ? AND (container_type IS NULL OR container_type = '')", Time.now - age).de

stroy_all

   end

-  def self.archive_attachments(out_file, attachments)

+  def self.archive_attachments(attachments)

     attachments = attachments.select(&:readable?)

     return nil if attachments.blank?

     Zip.unicode_names = true

     archived_file_names = []

-    Zip::File.open(out_file.path, Zip::File::CREATE) do |zip|

+    Zip::OutputStream.write_buffer do |zos|

       attachments.each do |attachment|

         filename = attachment.filename

         # rename the file if a file with the same name already exists

         dup_count = 0

         while archived_file_names.include?(filename)

           dup_count += 1

-          basename = File.basename(attachment.filename, '.*')

           extname = File.extname(attachment.filename)

+          basename = File.basename(attachment.filename, extname)

           filename = "#{basename}(#{dup_count})#{extname}" 

         end

-        zip.add(filename, attachment.diskfile)

+        zos.put_next_entry(filename)

+        zos << IO.binread(attachment.diskfile)

         archived_file_names << filename

       end

-    end

-    out_file

+    end.string

   end

   # Moves an existing attachment to its target directory

#35 - 2020-04-08 11:40 - Pavel Rosický

Yuichi HARADA thanks, it looks good!
but I'm getting a warning

zlib(finalizer): the stream was freed prematurely.

 the output StreamIO should be closed

#36 - 2020-04-08 12:11 - Pavel Rosický

- File zip-create-via-stream2.patch added

#37 - 2020-04-09 09:11 - Yuichi HARADA

- File zip-create-via-stream-v3.patch added

Pavel Rosický wrote:

Yuichi HARADA thanks, it looks good!

but I'm getting a warning

[...]

the output StreamIO should be closed

 Thanks for pointing it out.

I had forgotten to perform StringIO#close . Fixed a patch.

#38 - 2020-04-11 09:59 - Go MAEDA

- Status changed from Reopened to Closed

Pavel Rosický wrote:

unfortunately, this feature doesn't work on Windows.

[...]

I've attached a quick fix.

 Committed a fix for the issue in r19688. Thank you.

#39 - 2021-06-25 03:51 - Go MAEDA

- Related to Feature #35462: Download all attachments in a journal added

#40 - 2023-08-09 01:10 - Grubs _

v5.0.5.stable  and the download all files icon has some issues where the mouse hover over "flashes" and the shadow box with the text "Download all

files" does not always display.  If the mouse cursor is hovered over the download icon the cursor alternates between an arrow and hand at a cycle of

about 1 per second.

This issue is showing in "Documents", when there is more than one file attached to the document.

If the user clicks on the download all button it does work most times, but there is often no feedback to the user to indicate that their click on the

download arrow has registered. (particularly if there is a large number of files attached to the one Document)

This may be a jquerey issue with the css that is attempting to display the shadow box rather than a redmine issue. I don't know.

The function of the "download all" does work - but the user feedback seems off and users are spamming the download all button because they don't

know their click has registered.

Tested with Firefox 116.02 and Edge 115.0.1901.188 (on Windows 10 22H2)

P.S  great job on this BTW.  brilliant.  Apologies for re-opening.

#41 - 2023-08-09 09:45 - Mizuki ISHIKAWA

- File flashes.gif added

Grubs _ wrote in #note-40:

v5.0.5.stable  and the download all files icon has some issues where the mouse hover over "flashes" and the shadow box with the text
"Download all files" does not always display.  If the mouse cursor is hovered over the download icon the cursor alternates between an arrow and

hand at a cycle of about 1 per second.

This issue is showing in "Documents", when there is more than one file attached to the document.

If the user clicks on the download all button it does work most times, but there is often no feedback to the user to indicate that their click on the

download arrow has registered. (particularly if there is a large number of files attached to the one Document)

This may be a jquerey issue with the css that is attempting to display the shadow box rather than a redmine issue. I don't know.

The function of the "download all" does work - but the user feedback seems off and users are spamming the download all button because they

don't know their click has registered.

Tested with Firefox 116.02 and Edge 115.0.1901.188 (on Windows 10 22H2)

P.S  great job on this BTW.  brilliant.  Apologies for re-opening.

 I was able to reproduce this problem.

When the cursor is focused on an icon that exists on the right-hand side and tries to display a tooltip, the tooltip content breaks lines because it is at

the edge of the screen.

This causes the cursor to focus on the tooltip element that overlaps the icon and the tooltip, which is only visible when hovering over the icon,

disappears. After the tooltip disappears, the tooltip appears again because of the focus on the icon, disappears, and so on.

This is the likely cause of the blinking.

This problem is not limited to download links, but can occur with any icon that exists at the edge of the screen.

 flashes.gif 

#42 - 2023-08-09 15:49 - Grubs _

- File clipboard-202308092348-zmjsq.png added

Many thanks for the insight.

I fixed this by changing the CSS of my theme application.css to display the previously hidden link text "Download all files" which pushes the download

icon away from the left edge of the screen and fixes the flashing.

The Download All Icon now takes up more width and the popup is now redundant but users can find it much easier.  The small icon was not obvious

on the right edge of the screen.  I also changed the icon div container CSS so the file list begins below the download all link allowing the file names

and descriptions to use the full width of the screen.

/* puts the edit and Download all icon on its own line */

div.attachments .contextual {

  float: unset;

  text-align: right;

}

/* this displays the "Download all files" link text */

div.contextual .icon-download {

  width: unset;

  font-size: 13px;

  }

  clipboard-202308092348-zmjsq.png 

Files

compress_the_all_attachments_in_issue.patch 8.93 KB 2018-10-11 Mizuki ISHIKAWA

compress_the_all_attachments_in_issue_v2.patch 12.9 KB 2018-12-25 Mizuki ISHIKAWA

error_message.png 287 KB 2018-12-25 Mizuki ISHIKAWA

compress_the_all_attachments_in_issue_v3.patch 12.9 KB 2019-12-20 Mizuki ISHIKAWA

screenshot-v4.png 104 KB 2020-02-18 Go MAEDA

compress_the_all_attachments_in_issue_v4.patch 13.5 KB 2020-02-18 Go MAEDA

compress_the_all_attachments_in_issue_v5.patch 13.2 KB 2020-03-07 Go MAEDA

compress_the_all_attachments_in_issue_v6.patch 13.2 KB 2020-03-14 Go MAEDA

attachments-that-causes-EntryExistsError@2x.png 50.7 KB 2020-03-15 Go MAEDA

compress_the_all_attachments_in_issue_v7.patch 13.2 KB 2020-03-15 Go MAEDA

download.png 152 KB 2020-03-15 Marius BĂLTEANU

diff_v7_and_v8.patch 2.32 KB 2020-03-17 Mizuki ISHIKAWA

2025-08-23 9/10



compress_the_all_attachments_in_issue_v8.patch 13.4 KB 2020-03-17 Mizuki ISHIKAWA

human-readable-file-size.patch 1.85 KB 2020-03-22 Go MAEDA

file-size-before@2x.png 68 KB 2020-03-22 Go MAEDA

file-size-after@2x.png 67.1 KB 2020-03-22 Go MAEDA

download_all_fix.patch 3.81 KB 2020-03-24 Pavel Rosický

zip-create-via-stream.patch 4.61 KB 2020-04-08 Yuichi HARADA

zip-create-via-stream2.patch 5.06 KB 2020-04-08 Pavel Rosický

zip-create-via-stream-v3.patch 4.65 KB 2020-04-09 Yuichi HARADA

flashes.gif 476 KB 2023-08-09 Mizuki ISHIKAWA

clipboard-202308092348-zmjsq.png 42.8 KB 2023-08-09 Grubs _

Powered by TCPDF (www.tcpdf.org)

2025-08-23 10/10

http://www.tcpdf.org

